src/api/urls.py
# This file is part of Wolne Lektury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Wolne Lektury. See NOTICE for more information.
#
from django.urls import path, include
from django.views.decorators.csrf import csrf_exempt
from django.views.generic import TemplateView
import catalogue.views
from stats.utils import piwik_track_view
from . import views


urlpatterns1 = [
    path('register/', csrf_exempt(views.RegisterView.as_view())),
    path('refreshToken/', csrf_exempt(views.RefreshTokenView.as_view())),
    path('requestConfirm/', csrf_exempt(views.RequestConfirmView.as_view())),
    path('login/', csrf_exempt(views.Login2View.as_view())),
    path('me/', views.UserView.as_view()),
    path('', include('catalogue.api.urls2')),
]


urlpatterns = [
    path('2/', include((urlpatterns1, 'api'), namespace="v2")),

    path('oauth/request_token/', csrf_exempt(views.OAuth1RequestTokenView.as_view())),
    path('oauth/authorize/', views.oauth_user_auth, name='oauth_user_auth'),
    path('oauth/access_token/', csrf_exempt(views.OAuth1AccessTokenView.as_view())),
    path('login/', csrf_exempt(views.LoginView.as_view())),

    path('', TemplateView.as_view(template_name='api/main.html'), name='api'),

    # info boxes (used by mobile app)
    path('book/<int:book_id>/info.html', catalogue.views.book_info),
    path('tag/<int:tag_id>/info.html', catalogue.views.tag_info),

    # reading data
    path('reading/<slug:slug>/',
         piwik_track_view(views.BookUserDataView.as_view()),
         name='api_reading'),
    path('reading/<slug:slug>/<slug:state>/',
         piwik_track_view(views.BookUserDataView.as_view()),
         name='api_reading'),
    path('username/',
         piwik_track_view(views.UserView.as_view()),
         name='api_username'),

    path('blog',
         piwik_track_view(views.BlogView.as_view())),

    path('', include('social.api.urls')),
    path('', include('catalogue.api.urls')),

]

src/club/urls.py
# This file is part of Wolne Lektury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Wolne Lektury. See NOTICE for more information.
#
from django.urls import path
from django.views.generic import RedirectView
from annoy.utils import banner_exempt
from . import views


urlpatterns = [
    path('', banner_exempt(views.JoinView.as_view()), name='club_join'),
    path('dolacz/', RedirectView.as_view(
        url='/pomagam/', permanent=False)),
    path('info/', banner_exempt(views.ClubView.as_view()), name='club'),

    path('plan/<key>/', banner_exempt(views.ScheduleView.as_view()), name='club_schedule'),
    path('plan/<key>/dziekujemy/', banner_exempt(views.ScheduleThanksView.as_view()), name='club_thanks'),
    path('plan/<key>/zestawienie/<int:year>/', banner_exempt(views.YearSummaryView.as_view()), name='club_year_summary'),
    path('plan/<key>/rodzaj/', banner_exempt(views.DonationStep1.as_view()), name='donation_step1'),
    path('plan/<key>/dane/', banner_exempt(views.DonationStep2.as_view()), name='donation_step2'),

    path('przylacz/<key>/', views.claim, name='club_claim'),
    path('anuluj/<key>/', views.cancel, name='club_cancel'),

    path('platnosc/payu/cykl/<key>/', banner_exempt(views.PayURecPayment.as_view()), name='club_payu_rec_payment'),
    path('platnosc/payu/<key>/', banner_exempt(views.PayUPayment.as_view()), name='club_payu_payment'),

    path('notify/<int:pk>/', views.PayUNotifyView.as_view(), name='club_payu_notify'),

    path('weryfikacja/', views.member_verify, name='club_member_verify'),

    path('potwierdzenie/', views.receipt, name='club_receipt'),
]

src/waiter/urls.py
# This file is part of Wolne Lektury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Wolne Lektury. See NOTICE for more information.
#
from django.urls import path
from waiter import views

urlpatterns = [
    path('<path:path>', views.wait, name='waiter'),
]

src/club/models.py
# This file is part of Wolne Lektury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Wolne Lektury. See NOTICE for more information.
#
from datetime import datetime, timedelta
from decimal import Decimal
import os
import tempfile
from django.apps import apps
from django.conf import settings
from django.contrib.sites.models import Site
from django.core.mail import send_mail, EmailMessage
from django.urls import reverse
from django.db import models
from django import template
from django.utils.timezone import now, utc
from django.utils.translation import get_language
from django_countries.fields import CountryField
from catalogue.utils import get_random_hash
from messaging.states import Level
from reporting.utils import render_to_pdf
from .payment_methods import methods
from .payu import models as payu_models
from .civicrm import report_activity
from . import utils


class Club(models.Model):
    min_amount = models.IntegerField('minimalna kwota')
    min_for_year = models.IntegerField('minimalna kwota na rok')
    default_single_amount = models.IntegerField('domyślna kwota dla pojedynczej wpłaty')
    default_monthly_amount = models.IntegerField('domyślna kwota dla miesięcznych wpłat')

    class Meta:
        verbose_name = 'towarzystwo'
        verbose_name_plural = 'towarzystwa'
    
    def __str__(self):
        return 'Klub'

    def get_amounts(self):
        c = {}
        single = list(self.singleamount_set.all())
        monthly = list(self.monthlyamount_set.all())
        for tag, amounts in ('single', single), ('monthly', monthly):
            wide_spot = narrow_spot = 0
            for i, p in enumerate(amounts):
                if p.wide:
                    # Do we have space for xl?
                    if wide_spot < 2:
                        p.box_variant = 'xl'
                        wide_spot += 2
                    else:
                        p.box_variant = 'card'
                        wide_spot += 1
                    narrow_spot = 0
                elif p.description:
                    p.box_variant = 'card'
                    if narrow_spot:
                        amounts[i-1].box_variant = 'bar'
                    wide_spot += 1
                    narrow_spot = 0
                else:
                    p.box_variant = 'half'
                    wide_spot += 1
                    narrow_spot += 1
                wide_spot %= 3
                narrow_spot %= 2
            c[tag] = amounts
            c[f'{tag}_wide_spot'] = wide_spot
        return c

    def get_description_for_amount(self, amount, monthly):
        amounts = self.monthlyamount_set if monthly else self.singleamount_set
        amount = amounts.all().filter(amount__lte=amount).last()
        return amount.description if amount is not None else ''

    @property
    def paypal_enabled(self):
        print("ENABLED?", settings.PAYPAL_ENABLED)
        return settings.PAYPAL_ENABLED
    

class SingleAmount(models.Model):
    club = models.ForeignKey(Club, models.CASCADE)
    amount = models.IntegerField()
    description = models.TextField(blank=True)
    wide = models.BooleanField(default=False)

    class Meta:
        ordering = ['amount']

class MonthlyAmount(models.Model):
    club = models.ForeignKey(Club, models.CASCADE)
    amount = models.IntegerField()
    description = models.TextField(blank=True)
    wide = models.BooleanField(default=False)

    class Meta:
        ordering = ['amount']


class Consent(models.Model):
    order = models.IntegerField()
    active = models.BooleanField(default=True)
    text = models.CharField(max_length=2048)
    required = models.BooleanField()

    class Meta:
        ordering = ['order']
    
    def __str__(self):
        return self.text


class Schedule(models.Model):
    """ Represents someone taking up a plan. """
    key = models.CharField('klucz', max_length=255, unique=True)
    email = models.EmailField('e-mail')
    membership = models.ForeignKey(
        'Membership', verbose_name='członkostwo',
        null=True, blank=True, on_delete=models.SET_NULL)
    amount = models.DecimalField('kwota', max_digits=10, decimal_places=2)
    method = models.CharField('metoda płatności', max_length=32, choices=[
        (m.slug, m.name) for m in methods
        ])
    monthly = models.BooleanField('miesięcznie', default=True)
    yearly = models.BooleanField('rocznie', default=False)

    source = models.CharField('źródło', max_length=255, blank=True)

    is_cancelled = models.BooleanField('anulowany', default=False)
    payed_at = models.DateTimeField('opłacona', null=True, blank=True)
    started_at = models.DateTimeField('start', auto_now_add=True)
    expires_at = models.DateTimeField('wygasa', null=True, blank=True)
    email_sent = models.BooleanField(default=False)

    first_name = models.CharField(max_length=255, blank=True)
    last_name = models.CharField(max_length=255, blank=True)
    phone = models.CharField(max_length=255, blank=True)
    postal = models.CharField(max_length=255, blank=True)
    postal_code = models.CharField(max_length=255, blank=True)
    postal_town = models.CharField(max_length=255, blank=True)
    postal_country = CountryField(default='PL', blank=True)

    consent = models.ManyToManyField(Consent)
    
    class Meta:
        verbose_name = 'harmonogram'
        verbose_name_plural = 'harmonogramy'

    def __str__(self):
        return self.key

    def save(self, *args, **kwargs):
        if not self.key:
            self.key = get_random_hash(self.email)
        super(Schedule, self).save(*args, **kwargs)
        self.update_contact()

    def get_description(self):
        club = Club.objects.first()
        return club.get_description_for_amount(self.amount, self.monthly)

    def initiate_payment(self, request):
        return self.get_payment_method().initiate(request, self)

    def pay(self, request):
        return self.get_payment_method().pay(request, self)

    def get_absolute_url(self):
        return reverse('club_schedule', args=[self.key])

    def get_thanks_url(self):
        return reverse('club_thanks', args=[self.key])

    def get_payment_method(self):
        return [m for m in methods if m.slug == self.method][0]

    def get_payment_methods(self):
        for method in methods:
            if (self.monthly or self.yearly) and method.is_recurring:
                yield method
            elif not (self.monthly or self.yearly) and method.is_onetime:
                yield method

    def is_expired(self):
        return self.expires_at is not None and self.expires_at <= now()

    def is_active(self):
        return self.payed_at is not None and (self.expires_at is None or self.expires_at > now())

    def is_recurring(self):
        return self.monthly or self.yearly

    def set_payed(self):
        since = self.expires_at
        n = now()
        if since is None or since < n:
            since = n
        new_exp = self.get_next_installment(since)
        if self.payed_at is None:
            self.payed_at = n
        if self.expires_at is None or self.expires_at < new_exp:
            self.expires_at = new_exp
            self.save()

        if not self.email_sent:
            self.send_email()
    
    def get_next_installment(self, date):
        if self.yearly:
            return utils.add_year(date)
        if self.monthly:
            return utils.add_month(date)
        club = Club.objects.first()
        if club is not None and self.amount >= club.min_for_year:
            return utils.add_year(date)
        return utils.add_month(date)

    def get_other_active_recurring(self):
        schedules = type(self).objects.exclude(
            monthly=False, yearly=False
        ).filter(is_cancelled=False, expires_at__gt=now()).exclude(pk=self.pk)
        mine_q = models.Q(email=self.email)
        if self.membership is not None:
            mine_q |= models.Q(membership__user=self.membership.user)
        schedules = schedules.filter(mine_q)
        return schedules.order_by('-expires_at').first()
    
    def send_email(self):
        ctx = {'schedule': self}
        send_mail(
            template.loader.render_to_string('club/email/thanks_subject.txt', ctx).strip(),
            template.loader.render_to_string('club/email/thanks.txt', ctx),
            settings.CONTACT_EMAIL, [self.email], fail_silently=False)
        self.email_sent = True
        self.save()

    def send_email_failed_recurring(self):
        ctx = {
            'schedule': self,
            'other': self.get_other_active_recurring(),
        }
        send_mail(
            'Darowizna na Wolne Lektury — problem z płatnością',
            template.loader.render_to_string('club/email/failed_recurring.txt', ctx),
            settings.CONTACT_EMAIL, [self.email], fail_silently=False
        )
        
    def update_contact(self):
        Contact = apps.get_model('messaging', 'Contact')
        if not self.payed_at:
            level = Level.TRIED
            since = self.started_at
        else:
            since = self.payed_at
            if self.is_recurring():
                level = Level.RECURRING
            else:
                level = Level.SINGLE
        Contact.update(self.email, level, since, self.expires_at)





class Membership(models.Model):
    """ Represents a user being recognized as a member of the club. """
    user = models.OneToOneField(settings.AUTH_USER_MODEL, verbose_name='użytkownik', on_delete=models.CASCADE)
    created_at = models.DateTimeField('utworzone', auto_now_add=True)
    name = models.CharField('nazwa', max_length=255, blank=True)
    manual = models.BooleanField('ustawione ręcznie', default=False)
    notes = models.CharField('notatki', max_length=2048, blank=True)
    updated_at = models.DateField('aktualizacja', auto_now=True, blank=True)

    class Meta:
        verbose_name = 'członkostwo'
        verbose_name_plural = 'członkostwa'

    def __str__(self):

src/club/payu/forms.py
# This file is part of Wolne Lektury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Wolne Lektury. See NOTICE for more information.
#
from django import forms


class CardTokenForm(forms.Form):
    token = forms.CharField(widget=forms.HiddenInput)

    def get_queryset(self, view):
        raise NotImplementedError()

    def save(self, view):
        self.instance, created = self.get_queryset(view).get_or_create(
            pos_id=view.get_pos().pos_id,
            disposable_token=self.cleaned_data['token']
        )

src/club/payu/views.py
# This file is part of Wolne Lektury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Wolne Lektury. See NOTICE for more information.
#
from hashlib import md5, sha256
from django.conf import settings
from django import http
from django.shortcuts import get_object_or_404
from django.utils.decorators import method_decorator
from django.utils.translation import get_language
from django.views.decorators.csrf import csrf_exempt
from django.views.generic import FormView, TemplateView, View


class Payment(TemplateView):
    pass


class RecPayment(FormView):
    """ Set form_class to a CardTokenForm. """
    template_name = 'payu/rec_payment.html'

    def get_context_data(self, *args, **kwargs):
        ctx = super().get_context_data(*args, **kwargs)

        schedule = self.get_schedule()
        pos = self.get_pos()

        widget_args = {
            'merchant-pos-id': pos.pos_id,
            'shop-name': "SHOW NAME",
            'total-amount': str(int(schedule.amount * 100)),
            'currency-code': pos.currency_code,
            'customer-language': get_language(), # filter to pos.languages
            'customer-email': schedule.email,
            'store-card': 'true',
            'recurring-payment': 'true',
        }
        widget_sig = sha256(
            (
                "".join(v for (k, v) in sorted(widget_args.items())) +
                pos.secondary_key
            ).encode('utf-8')
        ).hexdigest()

        ctx['widget_args'] = widget_args
        ctx['widget_sig'] = widget_sig
        ctx['schedule'] = schedule
        ctx['pos'] = pos
        return ctx

    def form_valid(self, form):
        form.save(self)
        return super().form_valid(form)



@method_decorator(csrf_exempt, name='dispatch')
class NotifyView(View):
    """ Set `order_model` in subclass. """
    def post(self, request, pk):
        order = get_object_or_404(self.order_model, pk=pk)

        try:
            openpayu = request.META['HTTP_OPENPAYU_SIGNATURE']
            openpayu = dict(term.split('=') for term in openpayu.split(';'))
            assert openpayu['algorithm'] == 'MD5'
            assert openpayu['content'] == 'DOCUMENT'
            assert openpayu['sender'] == 'checkout'
            sig = openpayu['signature']
        except (KeyError, ValueError, AssertionError):
            return http.HttpResponseBadRequest('bad')

        document = request.body + order.get_pos().secondary_key.encode('latin1')
        if md5(document).hexdigest() != sig:
            return http.HttpResponseBadRequest('wrong')

        notification = order.notification_set.create(
            body=request.body.decode('utf-8')
        )
        notification.apply()

        return http.HttpResponse('ok')

src/club/templates/club/donation_step1.html
{% extends 'club/donation_step_base.html' %}

{% block donation-step-content %}
  {% include "club/donation_step1_form.html" %}
{% endblock %}

src/club/templates/club/donation_step1_form.html
{% load static %}
{% load i18n %}

<form method="post" action="{% url 'club_join' %}">
  {% csrf_token %}
  {{ form.errors }}
  <input type="radio" name="switch" id="switch-once" value="single" class="toggle-input" {% if schedule and not schedule.monthly %}checked{% endif %}>
  <input type="radio" name="switch" id="switch-monthly" value="monthly" class="toggle-input" {% if not schedule or schedule.monthly %}checked{% endif %}>
  <div class="l-switch__wrapper">
    {% if user.is_staff %}
      <span data-edit="club/club/{{ club.pk }}"></span>
    {% endif %}

    <div class="l-switch white">
      <label class='toggle-for' for="switch-once">{% trans "Jednorazowo" %}</label>
      <label class='toggle-for' for="switch-monthly">{% trans "Miesięcznie" %}</label>
      <span class="toggle"></span>
    </div>
  </div>

  {% with amounts=club.get_amounts %}
    <div class="l-checkout__payments payments-once wide-spot-{{ amounts.single_wide_spot }}">
      {% for amount in amounts.single %}
        <div class="l-checkout__payments__box once{% if not schedule.monthly and schedule.amount == amount.amount or not schedule and club.default_single_amount == amount.amount %} is-active{% endif %}{% if amount.wide %} l-checkout__payments__box--special{% endif %} l-checkout__payments__box--{{ amount.box_variant }}">

          <h3>{{ amount.amount }} zł</h3>
          <div class="l-checkout__payments__box__btn-wrp">
            {% if amount.description %}
              <p>{{ amount.description|safe }}</p>
            {% endif %}
            <button name="single_amount" value="{{ amount.amount }}">{% trans "Wybierz" %}</button>
          </div>
        </div>
      {% endfor %}
      <input type="hidden"
             name="single_amount_selected"
             value="{% if schedule and not schedule.monthly %}{{ schedule.amount|floatformat }}{% else %}{{ club.default_single_amount }}{% endif %}">

    </div>


    <div class="l-checkout__payments payments-recurring wide-spot-{{ amounts.monthly_wide_spot }}">
    {% for amount in amounts.monthly %}
      <div class="l-checkout__payments__box{% if schedule.monthly and schedule.amount == amount.amount or not schedule and amount.amount == club.default_monthly_amount %} is-active{% endif %}{% if amount.wide %} l-checkout__payments__box--special{% endif %} l-checkout__payments__box--{{ amount.box_variant }}">
        <h3>{{ amount.amount }} zł <span>{% trans "/mies." context "kwota na miesiąc" %}</span></h3>
        <div class="l-checkout__payments__box__btn-wrp">
          {% if amount.description %}
            <p>{{ amount.description|safe }}</p>
          {% endif %}
          <button name="monthly_amount" value="{{ amount.amount }}">{% trans "Wybierz" %}</button>
        </div>
      </div>
    {% endfor %}
    <input type="hidden"
           name="monthly_amount_selected"
           value="{% if schedule and schedule.monthly %}{{ schedule.amount|floatformat }}{% else %}{{ club.default_monthly_amount }}{% endif %}">
  </div>

  <div class="l-checkout__amount">
    <div class="l-checkout__input">
      <label for="kwota">{% trans "Inna kwota" %}</label>
      {{ form.custom_amount }}
    </div>
    <button>{% trans "Dalej" %}</button>
  </div>
  {% endwith %}
</form>

<div class="l-checkout__secure">
  <img src="{% static '2022/images/payments-padlock.png' %}" class="l-checkout__secure__padlock">
  {% trans "Bezpieczne płatności zapewniają" %}:
  <img src="{% static '2022/images/payments-payu.png' %}" class="l-checkout__secure__img" alt="PayU Visa MasterCard">
  {% if club.paypal_enabled %}
    <img src="{% static '2022/images/payments-paypal.png' %}" class="l-checkout__secure__img" alt="PayPal">
  {% endif %}
</div>

<div class="l-checkout__cols bt-w">
  <div class="l-checkout__col full">
    <div class="l-checkout__form">
      <div class="l-checkout__form__row full">
        <h3>{% trans "Dane do przelewu tradycyjnego" %}:</h3>
        {% include "club/transfer_info.html" %}
      </div>
    </div>
  </div>
</div>

src/club/templates/club/donation_step2.html
{% extends 'club/donation_step_base.html' %}
{% load i18n %}
{% load static %}


{% block donation-jumbo-image %}{% static '2022/images/checkout-img-2.jpg' %}{% endblock %}


{% block donation-step-content %}

  <div class="l-checkout__cols">
    <div class="l-checkout__col">
      <div class="l-checkout__payments__box is-active">
        <h3>
          {{ schedule.amount|floatformat }} zł
          {% if schedule.monthly %}
            <span>{% trans "/mies." context "kwota na miesiąc" %}</span>
          {% endif %}
        </h3>
        <img src="{% static '2022/images/checkout-img-3.jpg' %}" alt="">
        <p>{{ schedule.get_description }}</p>
      </div>
    </div>
    <div class="l-checkout__col">

      <form method='post'>
        {% csrf_token %}
        {{ form.errors }}
        {{ form.amount }}
        {{ form.monthly }}
        <div class="l-checkout__form">
          <div class="l-checkout__form__row">
            <div class="l-checkout__input">
              <label for="id_first_name"><span>*</span> {% trans "Imię" %}</label>
              {{ form.first_name }}
              {{ form.first_name.errors }}
            </div>
            <div class="l-checkout__input">
              <label for="id_last_name"><span>*</span> {% trans "Nazwisko" %}</label>
              {{ form.last_name }}
              {{ form.last_name.errors }}
            </div>
          </div>
          <div class="l-checkout__form__row">
            <div class="l-checkout__input">
              <label for="id_email"><span>*</span> {% trans "E-mail" %}</label>
              {{ form.email }}
              {{ form.email.errors }}
            </div>
            <div class="l-checkout__input">
              <label for="id_phone">{% trans "Telefon" %}</label>
              {{ form.phone }}
              {{ form.phone.errors }}
            </div>
          </div>
          <div class="l-checkout__form__row full">
            <div class="l-checkout__input">
              <label for="id_postal">{% trans "Adres pocztowy" %}</label>
              {{ form.postal }}
              {{ form.postal.errors }}
            </div>
          </div>
          <div class="l-checkout__form__row">
            <div class="l-checkout__input">
              <label for="id_postal_code">{% trans "Kod pocztowy" %}</label>
              {{ form.postal_code }}
              {{ form.postal_code.errors }}
            </div>
            <div class="l-checkout__input">
              <label for="id_postal_town">{% trans "Miejscowość" %}</label>
              {{ form.postal_town }}
              {{ form.postal_town.errors }}
            </div>
          </div>
          <div class="l-checkout__form__row full">
            <div class="l-checkout__input">
              <label for="id_postal_country">{% trans "Kraj" %}</label>
              {{ form.postal_country }}
              {{ form.postal_country.errors }}
            </div>
          </div>
          <div class="l-checkout__form__row full">
            {% for consent, key, field in form.consent %}
              {{ field.errors }}
              <div class="c-checkbox">
                {{ field }}
                <label for="id_{{ key }}">
                  <p>{% if field.field.required %}<span>*</span> {% endif %}{{ field.label }}</p>
                </label>
              </div>
            {% endfor %}
            <div class="c-checkbox">
              {{ form.agree_newsletter }}
              <label for="id_agree_newsletter">
                <p>{% trans "Zapisuję się na newsletter." %}</p>
              </label>
            </div>
          </div>
          <div class="l-checkout__form__row confirm">
            <a href="{% url 'donation_step1' schedule.key %}">{% trans "Powrót" %}</a>
            <div class="l-checkout__input">
              <button>{% trans "Dalej" %}</button>
            </div>
          </div>
        </div>
      </form>
    </div>
  </div>
  <div class="l-checkout__secure">
    <img src="{% static '2022/images/payments-padlock.png' %}" class="l-checkout__secure__padlock">
    {% trans "Bezpieczne płatności zapewniają" %}:
    <img src="{% static '2022/images/payments-payu.png' %}" class="l-checkout__secure__img" alt="PayU Visa MasterCard">
    {% if club.paypal_enabled %}
      <img src="{% static '2022/images/payments-paypal.png' %}" class="l-checkout__secure__img" alt="PayPal">
    {% endif %}
  </div>
{% endblock %}

src/club/templates/club/donation_step3.html
{% extends 'club/donation_step_base.html' %}
{% load i18n %}
{% load static %}
{% load club %}


{% block donation-jumbo-image %}{% static '2022/images/checkout-img-4.jpg' %}{% endblock %}


{% block donation-step-content %}
  <div class="l-checkout__cols">
    <div class="l-checkout__col">
      <div class="l-checkout__payments__box is-active">
        <h3>
          {{ schedule.amount|floatformat }} zł
          {% if schedule.monthly %}
            <span>{% trans "/mies." context "kwota na miesiąc" %}</span>
          {% endif %}</h3>
          <img src="{% static '2022/images/checkout-img-3.jpg' %}" alt="">
      </div>
    </div>
    <div class="l-checkout__col">
      <div class="l-checkout__form">
        <div class="l-checkout__form__row full">
          <div class="iframe">
            {% for method in schedule.get_payment_methods %}
              {% invite_payment method schedule %}
            {% endfor %}
          </div>
        </div>
        <div class="l-checkout__form__row full">
          <h3>{% trans "Możesz też ustawić stały przelew na konto:" %}</h3>
          {% include "club/transfer_info.html" %}
        </div>
        <div class="l-checkout__form__row confirm">
          <a href="{% url 'donation_step2' schedule.key %}">{% trans "Powrót" %}</a>
        </div>
      </div>
    </div>
  </div>
  <div class="l-checkout__secure">
    <img src="{% static '2022/images/payments-padlock.png' %}" class="l-checkout__secure__padlock">
    {% trans "Bezpieczne płatności zapewniają" %}:
    <img src="{% static '2022/images/payments-payu.png' %}" class="l-checkout__secure__img" alt="PayU Visa MasterCard">
    {% if club.paypal_enabled %}
      <img src="{% static '2022/images/payments-paypal.png' %}" class="l-checkout__secure__img" alt="PayPal">
    {% endif %}
  </div>
{% endblock %}

src/club/templates/club/donation_step4.html
{% extends 'club/donation_step_base.html' %}
{% load i18n %}


{% block donation-step-content %}
  <div class="l-checkout__completed">
    <div class="l-checkout__completed__wrapper">
      <h1>{% trans "Dziękujemy za wpłatę!" %}</h1>
      <p>
        {% blocktrans trimmed %}
          Zajrzyj teraz do e-maila. Tam znajdziesz link,
          który powiąże płatność z Twoim kontem użytkownika Wolnych Lektur.
        {% endblocktrans %}
      </p>
      <a href="/">{% trans "Wracam do lektur" %}</a>
    </div>
  </div>
{% endblock %}

src/club/templates/club/index.html
{% extends "base_simple.html" %}
{% load i18n %}
{% load active_schedule from club %}
{% load chunks %}


{% block titleextra %}{% trans "Wolne Lektury potrzebują Twojej pomocy!" %}{% endblock %}


{% block body %}

  <h1>{% trans "Wolne Lektury potrzebują Twojej pomocy!" %}</h1>
  <div class="white-box normal-text">

    {% chunk 'club' %}

    <p style="margin-top: 2em;">
      {% with schedule=request.user|active_schedule %}
        {% if schedule %}
          <a href="{{ schedule.get_absolute_url }}">{% trans "Gratulacje — wspierasz Wolne Lektury!" %}</a>
        {% else %}
          <a style="background:#018189;color:white;border-radius: 10px;padding:1em 2em" href="{% url 'club_join' %}">{% trans "Zacznij wspierać" %}</a>
        {% endif %}
      {% endwith %}
    </p>
  </div>

{% endblock %}